//
//  KPParser.m
//  KnitPicker
//
//  Created by James Dessart on 27/12/04.
//  Copyright 2004 __MyCompanyName__. All rights reserved.
//

#import "KPParser.h"

extern void scanStringForStitchCounts( const char *inString, stitchCounts *ioCounts );

@implementation KPParser

- (id)init
{
	if( self != 0 )
	{
		[self setStitches:[NSNumber numberWithInt:0]];
		[self setExpectedPreviousRowStitches:[NSNumber numberWithInt:0]];
		
		rowString = [[NSString alloc] init];
	}
	
	return self;
}

- (NSNumber*)stitches
{
	return stitches;
}

- (void)setStitches:(NSNumber*)stitchCount
{
	[stitchCount retain];
	
	[stitches autorelease];
	
	stitches = stitchCount;
}

- (NSNumber*)expectedPreviousRowStitches
{
	return expectedPreviousRowStitches;
}

- (void)setExpectedPreviousRowStitches:(NSNumber*)stitchCount
{
	[stitchCount retain];
	
	[expectedPreviousRowStitches autorelease];
	
	expectedPreviousRowStitches = stitchCount;
}

- (NSString*)rowString
{
	return rowString;
}

- (void)setRowString:(NSString*)string;
{
	int expectedPrevious;
	int expectedCurrent;

	[string retain];
	
	[rowString autorelease];
	
	rowString = string;
	
	if( [rowString length] < 1 )
	{
		expectedPrevious = expectedCurrent = 0;
	}
	else
	{
		scanStringForStitchCounts( [rowString lossyCString], &(self->stitchCounts) );
		
		expectedPrevious = (self->stitchCounts).base_stitch_count + (self->stitchCounts).remove_stitch_count;
		
		expectedCurrent = (self->stitchCounts).base_stitch_count + (self->stitchCounts).add_stitch_count;
	}
	
	[self setExpectedPreviousRowStitches:[NSNumber numberWithInt:expectedPrevious]];
	[self setStitches:[NSNumber numberWithInt:expectedCurrent]];
}

@end
