%{
/* need this for the call to atoi() below */
#include <math.h>
#include <stdio.h>
%}

/* Variable definitions */
	int		base_stitch_count = 0;
	int		add_stitch_count = 0;
	int		remove_stitch_count = 0;
	int		temp, temp1;

TWO		[ \t]*2[ \t]*
NUMBER	[ \t]*[0-9]+[ \t]*

%option noyywrap

%%

k{TWO}t(og)?	{
		remove_stitch_count += 1;
		base_stitch_count += 1;
	}

p{TWO}t(og)?	{
		remove_stitch_count += 1;
		base_stitch_count += 1;
	}

psso				remove_stitch_count += 1;

skpo?		{
		remove_stitch_count += 1;
		base_stitch_count += 1;
	}

ss[kp]		{
		remove_stitch_count += 1;
		base_stitch_count += 1;
	}

dd		{
		remove_stitch_count += 2;
		base_stitch_count += 1;
	}

sssk	{
		remove_stitch_count += 2;
		base_stitch_count += 1;
	}

sl1k{TWO}togpsso	{
		remove_stitch_count += 2;
		base_stitch_count += 1;
	}

sl1k3togpsso	{
		remove_stitch_count += 3;
		base_stitch_count += 1;
	}

m1[lr]?				add_stitch_count += 1;

"yo twice"			add_stitch_count += 2;

yo{TWO}				add_stitch_count += 2;

y?o					add_stitch_count += 1;

di		{
		add_stitch_count += 2;
		base_stitch_count += 1;
	}

k{NUMBER}		{
		sscanf( yytext, "k%d", &temp );
		base_stitch_count += temp;
	}

p{NUMBER}		{
		sscanf( yytext, "p%d", &temp );
		base_stitch_count += temp;
	}

sl{NUMBER}k{NUMBER}psso	{
		sscanf( yytext, "sl%dk%d", &temp, &temp1 );
		base_stitch_count += temp1;
		remove_stitch_count += temp;
	}

sl{NUMBER}(k|wyif)?	{
		sscanf( yytext, "sl%d", &temp );
		base_stitch_count += temp;
	}

ssw		{
		base_stitch_count += 2;
	}

syif	{
		base_stitch_count += 1;
	}

[ \t\n]+			/* Ignore whitespace */

.					/* Oops! don't know this one! */

%%

typedef struct
{
	int		base_stitch_count;
	int		add_stitch_count;
	int		remove_stitch_count;
} stitchCounts;

extern int yylex();

void scanForStitchCounts( stitchCounts *ioCounts )
{
	/* Need to make sure we clear these before each run through the lexer */
	base_stitch_count = 0;
	add_stitch_count = 0;
	remove_stitch_count = 0;

	yylex();
	
	ioCounts->base_stitch_count = base_stitch_count;
	ioCounts->add_stitch_count = add_stitch_count;
	ioCounts->remove_stitch_count = remove_stitch_count;
}

void scanStringForStitchCounts( const char *inString, stitchCounts *ioCounts )
{
	YY_BUFFER_STATE buffer = yy_scan_string( inString );
	
	scanForStitchCounts( ioCounts );
	
	yy_delete_buffer( buffer );
}
